SystemOrganization addCategory: #Dice!

TestCase subclass: #DiceHandleTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Dice'!

!DiceHandleTest methodsFor: 'tests' stamp: 'Anonymous 1/20/2017 12:49'!
testCreationAdding

|handle|
handle:=DiceHandle new.
handle addDie: (Dice new).
self assert: handle  diceNumber equals: 1.
handle addDie: (Dice new faces: 20).
self assert: handle diceNumber equals: 2! !

!DiceHandleTest methodsFor: 'tests' stamp: 'Anonymous 1/20/2017 12:57'!
testCreationHandle

|handle|
handle:= (2 D20) + (4 D:20).! !

!DiceHandleTest methodsFor: 'tests' stamp: 'Anonymous 1/20/2017 12:55'!
testRolling


|handle|
handle:=DiceHandle new.
handle addDie: (Dice new).
handle addDie: (Dice new faces: 20).
10 timesRepeat: [ self assert: (handle roll between: 2 and: 26) ]! !

TestCase subclass: #DiceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Dice'!

!DiceTest methodsFor: 'tests' stamp: 'pharoGsix 1/20/2017 13:44'!
testCreationIsOK

	|d|
	d := Dice new faces:20.
	self assert: d getFaces equals: 20! !

!DiceTest methodsFor: 'tests' stamp: 'DonaldTrump 1/13/2017 15:15'!
testInitializeIsOK

	self shouldnt: [ Dice new ] raise: Error.
	self assert: Dice new getFaces  equals: 6.! !

!DiceTest methodsFor: 'tests' stamp: 'DonaldTrump 1/13/2017 15:20'!
testRolling

	|d|
	d:=Dice new.
	10 timesRepeat: [ self assert: (d roll between: 1 and: 6 ) ]! !

Object subclass: #Dice
	instanceVariableNames: 'faces'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Dice'!

!Dice methodsFor: 'setting' stamp: 'pharoGsix 1/20/2017 13:43'!
faces: aNumber

	faces := aNumber 
	! !

!Dice methodsFor: 'accesing' stamp: 'DonaldTrump 1/13/2017 15:22'!
getFaces

	^ faces! !

!Dice methodsFor: 'initialization' stamp: 'pharoGsix 1/20/2017 13:44'!
initialize
	
	faces := 6.! !

!Dice methodsFor: 'printing' stamp: 'pharoGsix 1/20/2017 13:52'!
printOn: aStream

	super printOn: aStream.
	aStream << '('.
	aStream << faces printString.
	aStream << ')'! !

!Dice methodsFor: 'rolling' stamp: 'DonaldTrump 1/13/2017 15:08'!
roll

	^ faces atRandom ! !

Object subclass: #DiceHandle
	instanceVariableNames: 'dice'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Dice'!

!DiceHandle methodsFor: 'arithmetic' stamp: 'pharoGsix 1/20/2017 15:02'!
+ aHundle

|hundle|
hundle := DiceHandle new.
aHundle dice do:[:each|hundle addDie: each].
dice do: [ :each | hundle addDie: each].
^ hundle! !

!DiceHandle methodsFor: 'setting' stamp: 'DonaldTrump 1/13/2017 15:33'!
addDie: aDie
	

	dice add: aDie! !

!DiceHandle methodsFor: 'accessing' stamp: 'Anonymous 1/20/2017 13:03'!
dice

^ self dice! !

!DiceHandle methodsFor: 'accessing' stamp: 'DonaldTrump 1/13/2017 15:39'!
diceNumber

	^ dice size ! !

!DiceHandle methodsFor: 'initialization' stamp: 'DonaldTrump 1/13/2017 15:31'!
initialize

	dice:= OrderedCollection new.! !

!DiceHandle methodsFor: 'handle' stamp: 'DonaldTrump 1/13/2017 15:49'!
roll

	|n|
	n:=0.
	dice do: [ :each| n:=n+each roll ].
	^ n! !

!Integer methodsFor: '*Dice' stamp: 'pharoGsix 1/20/2017 14:56'!
D20

	^ self D:20! !

!Integer methodsFor: '*Dice' stamp: 'Anonymous 1/20/2017 13:00'!
D6

^ Dice new ! !

!Integer methodsFor: '*Dice' stamp: 'pharoGsix 1/20/2017 13:48'!
D: aNumber
 	| h |
	h := DiceHandle new.
 	self timesRepeat: [ h addDie: (Dice new faces: aNumber)].
	^h ! !
